<?php
/**
 * Theme Menuitem Extension Walker
 * only included when on the wp-admin/nav-menus.php page.
 */
namespace Greyd\Navigation;

if ( !defined( 'ABSPATH' ) ) exit;

class Admin_Menu_Walker extends \Walker_Nav_Menu_Edit {

	/**
	 * Start the element output.
	 * injecting custom fields after the div.submitbox
	 */
	function start_el( &$output, $item, $depth = 0, $args = null, $id = 0 ) {
		$item_output = '';
		parent::start_el( $item_output, $item, $depth, $args, $id );
		$output .= preg_replace(
			// NOTE: Check this regex from time to time!
			'/(?=<(fieldset|p)[^>]+class="[^"]*field-move)/',
			$this->get_fields( $item, $depth, $args, $id ),
			$item_output
		);
	}

	/**
	 * Get menu item custom fields from plugins/themes
	 */
	protected function get_fields( $item, $depth, $args = null, $id = 0 ) {
		ob_start();
		do_action( 'wp_nav_menu_item_fields', $item->ID, $item, $depth, $args, $id );
		return ob_get_clean();
	}
}
